Similarity (Lucene 3.6.2 API)
Keywords: org.apache.lucene.search.Similarity class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.search
Class Similarity

    java.lang.Object
      org.apache.lucene.search.Similarity

All Implemented Interfaces:
  Serializable

Direct Known Subclasses:
  DefaultSimilarity, SimilarityDelegator

    public abstract class Similarity

extends Object
implements Serializable

Expert: Scoring API.

Similarity defines the components of Lucene scoring. Overriding computation of these components is a convenient way to alter Lucene scoring.

Suggested reading: Introduction To Information Retrieval, Chapter 6.

The following describes how Lucene scoring evolves from underlying information retrieval models to (efficient) implementation. We first brief on VSM Score, then derive from it Lucene's Conceptual Scoring Formula, from which, finally, evolves Lucene's Practical Scoring Function (the latter is connected directly with Lucene classes and methods).

Lucene combines Boolean model (BM) of Information Retrieval with Vector Space Model (VSM) of Information Retrieval - documents "approved" by BM are scored by VSM.

In VSM, documents and queries are represented as weighted vectors in a multi-dimensional space, where each distinct index term is a dimension, and weights are Tf-idf values.

VSM does not require weights to be Tf-idf values, but Tf-idf values are believed to produce search results of high quality, and so Lucene is using Tf-idf. Tf and Idf are described in more detail below, but for now, for completion, let's just say that for given term t and document (or query) x, Tf(t,x) varies with the number of occurrences of term t in x (when one increases so does the other) and idf(t) similarly varies with the inverse of the number of index documents containing term t.

VSM score of document d for query q is the Cosine Similarity of the weighted query vectors V(q) and V(d):

cosine-similarity(q,d) = |
V(q) · V(d)
–––––––––
|V(q)| |V(d)|
VSM Score

Where V(q) · V(d) is the dot product of the weighted vectors, and |V(q)| and |V(d)| are their Euclidean norms.

Note: the above equation can be viewed as the dot product of the normalized weighted vectors, in the sense that dividing V(q) by its euclidean norm is normalizing it to a unit vector.

Lucene refines VSM score for both search quality and usability:

- Normalizing V(d) to the unit vector is known to be problematic in that it removes all document length information. For some documents removing this info is probably ok, e.g. a document made by duplicating a certain paragraph 10 times, especially if that paragraph is made of distinct terms. But for a document which contains no duplicated paragraphs, this might be wrong. To avoid this problem, a different document length normalization factor is used, which normalizes to a vector equal to or larger than the unit vector: doc-len-norm(d).
- At indexing, users can specify that certain documents are more important than others, by assigning a document boost. For this, the score of each document is also multiplied by its boost value doc-boost(d).
- Lucene is field based, hence each query term applies to a single field, document length normalization is by the length of the certain field, and in addition to document boost there are also document fields boosts.
- The same field can be added to a document during indexing several times, and so the boost of that field is the multiplication of the boosts of the separate additions (or parts) of that field within the document.
- At search time users can specify boosts to each query, sub-query, and each query term, hence the contribution of a query term to the score of a document is multiplied by the boost of that query term query-boost(q).
- A document may match a multi term query without containing all the terms of that query (this is correct for some of the queries), and users can further reward documents matching more query terms through a coordination factor, which is usually larger when more terms are matched: coord-factor(q,d).

Under the simplifying assumption of a single field in the index, we get Lucene's Conceptual scoring formula:

score(q,d) = coord-factor(q,d) · query-boost(q) · |
V(q) · V(d)
–––––––––
|V(q)|
| · doc-len-norm(d) · doc-boost(d)
Lucene Conceptual Scoring Formula

The conceptual formula is a simplification in the sense that (1) terms and documents are fielded and (2) boosts are usually per query term rather than per query.

We now describe how Lucene implements this conceptual scoring formula, and derive from it Lucene's Practical Scoring Function.

For efficient score computation some scoring components are computed and aggregated in advance:

- Query-boost for the query (actually for each query term) is known when search starts.
- Query Euclidean norm |V(q)| can be computed when search starts, as it is independent of the document being scored. From search optimization perspective, it is a valid question why bother to normalize the query at all, because all scored documents will be multiplied by the same |V(q)|, and hence documents ranks (their order by score) will not be affected by this normalization. There are two good reasons to keep this normalization:
  - Recall that Cosine Similarity can be used find how similar two documents are. One can use Lucene for e.g. clustering, and use a document as a query to compute its similarity to other documents. In this use case it is important that the score of document d3 for query d1 is comparable to the score of document d3 for query d2. In other words, scores of a document for two distinct queries should be comparable. There are other applications that may require this. And this is exactly what normalizing the query vector V(q) provides: comparability (to a certain extent) of two or more queries.
  - Applying query normalization on the scores helps to keep the scores around the unit vector, hence preventing loss of score data because of floating point precision limitations.
- Document length norm doc-len-norm(d) and document boost doc-boost(d) are known at indexing time. They are computed in advance and their multiplication is saved as a single value in the index: norm(d). (In the equations below, norm(t in d) means norm(field(t) in doc d) where field(t) is the field associated with term t.)

Lucene's Practical Scoring Function is derived from the above. The color codes demonstrate how it relates to those of the conceptual formula:

score(q,d) = coord(q,d) · queryNorm(q) · | ∑ | ( tf(t in d) · idf(t)2 · t.getBoost() · norm(t,d) )
| t in q |
Lucene Practical Scoring Function

where

1. tf(t in d) correlates to the term's frequency, defined as the number of times term t appears in the currently scored document d. Documents that have more occurrences of a given term receive a higher score. Note that tf(t in q) is assumed to be 1 and therefore it does not appear in this equation, However if a query contains twice the same term, there will be two term-queries with that same term and hence the computation would still be correct (although not very efficient). The default computation for tf(t in d) in `DefaultSimilarity` is:

   `tf(t in d)` = | frequency½

2. idf(t) stands for Inverse Document Frequency. This value correlates to the inverse of docFreq (the number of documents in which the term t appears). This means rarer terms give higher contribution to the total score. idf(t) appears for t in both the query and the document, hence it is squared in the equation. The default computation for idf(t) in `DefaultSimilarity` is:

   `idf(t)` = | 1 + log ( |
   numDocs
   –––––––––
   docFreq+1
   | )

3. coord(q,d) is a score factor based on how many of the query terms are found in the specified document. Typically, a document that contains more of the query's terms will receive a higher score than another document with fewer query terms. This is a search time factor computed in `coord(q,d)` by the Similarity in effect at search time.
4. queryNorm(q) is a normalizing factor used to make scores between queries comparable. This factor does not affect document ranking (since all ranked documents are multiplied by the same factor), but rather just attempts to make scores from different queries (or even different indexes) comparable. This is a search time factor computed by the Similarity in effect at search time. The default computation in `DefaultSimilarity` produces a Euclidean norm:

   queryNorm(q) = `queryNorm(sumOfSquaredWeights)` = |
   1
   ––––––––––––––
   sumOfSquaredWeights½

   The sum of squared weights (of the query terms) is computed by the query `Weight` object. For example, a `BooleanQuery` computes this value as:

   `sumOfSquaredWeights` = `q.getBoost()` 2 · | ∑ | ( idf(t) · t.getBoost() ) 2
   | t in q |

5. t.getBoost() is a search time boost of term t in the query q as specified in the query text (see query syntax), or as set by application calls to `setBoost()`. Notice that there is really no direct API for accessing a boost of one term in a multi term query, but rather multi terms are represented in a query as multi `TermQuery` objects, and so the boost of a term in the query is accessible by calling the sub-query `getBoost()`.
6. norm(t,d) encapsulates a few (indexing time) boost and length factors:
   - Document boost - set by calling `doc.setBoost()` before adding the document to the index.
   - Field boost - set by calling `field.setBoost()` before adding the field to a document.
   - lengthNorm - computed when the document is added to the index in accordance with the number of tokens of this field in the document, so that shorter fields contribute more to the score. LengthNorm is computed by the Similarity class in effect at indexing.
   The `computeNorm(java.lang.String, org.apache.lucene.index.FieldInvertState)` method is responsible for combining all of these factors into a single float.

   When a document is added to the index, all the above factors are multiplied. If the document has multiple fields with the same name, all their boosts are multiplied together:

   norm(t,d) = `doc.getBoost()` · lengthNorm · | ∏ | `f.getBoost`()
   | field f in d named as t |

   However the resulted norm value is `encoded` as a single byte before being stored. At search time, the norm byte value is read from the index `directory` and `decoded` back to a float norm value. This encoding/decoding, while reducing index size, comes with the price of precision loss - it is not guaranteed that decode(encode(x)) = x. For instance, decode(encode(0.89)) = 0.75.
   Compression of norm values to a single byte saves memory at search time, because once a field is referenced at search time, its norms - for all documents - are maintained in memory.
   The rationale supporting such lossy compression of norm values is that given the difficulty (and inaccuracy) of users to express their true information need by a query, only big differences matter.
   Last, note that search time is too late to modify this norm part of scoring, e.g. by using a different `Similarity` for search.

See Also:
  `setDefault(Similarity)`, `IndexWriter.setSimilarity(Similarity)`, `Searcher.setSimilarity(Similarity)`, Serialized Form

Field Summary
`static int` | `NO_DOC_ID_PROVIDED`

Constructor Summary
`Similarity()`

Method Summary
`abstract float` | `computeNorm(String field, FieldInvertState state)` Computes the normalization value for a field, given the accumulated state of term processing for this field (see `FieldInvertState`).
`abstract float` | `coord(int overlap, int maxOverlap)` Computes a score factor based on the fraction of all query terms that a document contains.
`static float` | `decodeNorm(byte b)` Deprecated. Use `decodeNormValue(byte)` instead.
`float` | `decodeNormValue(byte b)` Decodes a normalization factor stored in an index.
`static byte` | `encodeNorm(float f)` Deprecated. Use `encodeNormValue(float)` instead.
`byte` | `encodeNormValue(float f)` Encodes a normalization factor for storage in an index.
`static Similarity` | `getDefault()` Return the default Similarity implementation used by indexing and search code.
`static float[]` | `getNormDecoder()` Deprecated. Use instance methods for encoding/decoding norm values to enable customization.
`abstract float` | `idf(int docFreq, int numDocs)` Computes a score factor based on a term's document frequency (the number of documents which contain the term).
`Explanation.IDFExplanation` | `idfExplain(Collection<Term> terms, Searcher searcher)` Computes a score factor for a phrase.
`Explanation.IDFExplanation` | `idfExplain(Term term, Searcher searcher)` This method forwards to `idfExplain(Term,Searcher,int)` by passing `searcher.docFreq(term)` as the docFreq.
`Explanation.IDFExplanation` | `idfExplain(Term term, Searcher searcher, int docFreq)` Computes a score factor for a simple term and returns an explanation for that score factor.
`float` | `lengthNorm(String fieldName, int numTokens)` Deprecated. Please override computeNorm instead
`abstract float` | `queryNorm(float sumOfSquaredWeights)` Computes the normalization value for a query given the sum of the squared weights of each of the query terms.
`float` | `scorePayload(int docId, String fieldName, int start, int end, byte[] payload, int offset, int length)` Calculate a scoring factor based on the data in the payload.
`static void` | `setDefault(Similarity similarity)` Set the default Similarity implementation used by indexing and search code.
`abstract float` | `sloppyFreq(int distance)` Computes the amount of a sloppy phrase match, based on an edit distance.
`abstract float` | `tf(float freq)` Computes a score factor based on a term or phrase's frequency in a document.
`float` | `tf(int freq)` Computes a score factor based on a term or phrase's frequency in a document.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### NO_DOC_ID_PROVIDED

    public static final int NO_DOC_ID_PROVIDED

See Also:
  Constant Field Values

Constructor Detail

### Similarity

    public Similarity()

Method Detail

### setDefault

    public static void setDefault(Similarity similarity)

  Set the default Similarity implementation used by indexing and search code.

  See Also:
    `Searcher.setSimilarity(Similarity)`, `IndexWriter.setSimilarity(Similarity)`

### getDefault

    public static Similarity getDefault()

  Return the default Similarity implementation used by indexing and search code.

  This is initially an instance of `DefaultSimilarity`.

  See Also:
    `Searcher.setSimilarity(Similarity)`, `IndexWriter.setSimilarity(Similarity)`

### decodeNorm

    @Deprecated
    public static float decodeNorm(byte b)

  Deprecated. Use `decodeNormValue(byte)` instead.

  Decodes a normalization factor stored in an index.

  See Also:
    `decodeNormValue(byte)`

### decodeNormValue

    public float decodeNormValue(byte b)

  Decodes a normalization factor stored in an index.

  WARNING: If you override this method, you should change the default Similarity to your implementation with `setDefault(Similarity)`. Otherwise, your method may not always be called, especially if you omit norms for some fields.

  See Also:
    `encodeNormValue(float)`

### getNormDecoder

    @Deprecated
    public static float[] getNormDecoder()

  Deprecated. Use instance methods for encoding/decoding norm values to enable customization.

  Returns a table for decoding normalization bytes.

  See Also:
    `encodeNormValue(float)`, `decodeNormValue(byte)`

### computeNorm

    public abstract float computeNorm(String field,
                                      FieldInvertState state)

  Computes the normalization value for a field, given the accumulated state of term processing for this field (see `FieldInvertState`).

  Implementations should calculate a float value based on the field state and then return that value.

  Matches in longer fields are less precise, so implementations of this method usually return smaller values when `state.getLength()` is large, and larger values when `state.getLength()` is small.

  Note that the return values are computed under `IndexWriter.addDocument(org.apache.lucene.document.Document)` and then stored using `encodeNormValue(float)`. Thus they have limited precision, and documents must be re-indexed if this method is altered.

  For backward compatibility this method by default calls `lengthNorm(String, int)` passing `FieldInvertState.getLength()` as the second argument, and then multiplies this value by `FieldInvertState.getBoost()`.

  Parameters:
    `field` - field name
    `state` - current processing state for this field
  Returns:
    the calculated float norm
  WARNING: This API is experimental and might change in incompatible ways in the next release.

### lengthNorm

    @Deprecated
    public final float lengthNorm(String fieldName,
                                             int numTokens)

  Deprecated. Please override computeNorm instead

  Computes the normalization value for a field given the total number of terms contained in a field. These values, together with field boosts, are stored in an index and multipled into scores for hits on each field by the search code.

  Matches in longer fields are less precise, so implementations of this method usually return smaller values when `numTokens` is large, and larger values when `numTokens` is small.

  Note that the return values are computed under `IndexWriter.addDocument(org.apache.lucene.document.Document)` and then stored using `encodeNormValue(float)`. Thus they have limited precision, and documents must be re-indexed if this method is altered.

  Parameters:
    `fieldName` - the name of the field
    `numTokens` - the total number of tokens contained in fields named fieldName of doc.
  Returns:
    a normalization factor for hits on this field of this document
  See Also:
    `AbstractField.setBoost(float)`

### queryNorm

    public abstract float queryNorm(float sumOfSquaredWeights)

  Computes the normalization value for a query given the sum of the squared weights of each of the query terms. This value is multiplied into the weight of each query term. While the classic query normalization factor is computed as 1/sqrt(sumOfSquaredWeights), other implementations might completely ignore sumOfSquaredWeights (ie return 1).

  This does not affect ranking, but the default implementation does make scores from different queries more comparable than they would be by eliminating the magnitude of the Query vector as a factor in the score.

  Parameters:
    `sumOfSquaredWeights` - the sum of the squares of query term weights
  Returns:
    a normalization factor for query weights

### encodeNormValue

    public byte encodeNormValue(float f)

  Encodes a normalization factor for storage in an index.

  The encoding uses a three-bit mantissa, a five-bit exponent, and the zero-exponent point at 15, thus representing values from around 7x10^9 to 2x10^-9 with about one significant decimal digit of accuracy. Zero is also represented. Negative numbers are rounded up to zero. Values too large to represent are rounded down to the largest representable value. Positive values too small to represent are rounded up to the smallest positive representable value.

  WARNING: If you override this method, you should change the default Similarity to your implementation with `setDefault(Similarity)`. Otherwise, your method may not always be called, especially if you omit norms for some fields.

  See Also:
    `AbstractField.setBoost(float)`, `SmallFloat`

### encodeNorm

    @Deprecated
    public static byte encodeNorm(float f)

  Deprecated. Use `encodeNormValue(float)` instead.

  Static accessor kept for backwards compability reason, use encodeNormValue instead.

  Parameters:
    `f` - norm-value to encode
  Returns:
    byte representing the given float
  See Also:
    `encodeNormValue(float)`

### tf

    public float tf(int freq)

  Computes a score factor based on a term or phrase's frequency in a document. This value is multiplied by the `idf(int, int)` factor for each term in the query and these products are then summed to form the initial score for a document.

  Terms and phrases repeated in a document indicate the topic of the document, so implementations of this method usually return larger values when `freq` is large, and smaller values when `freq` is small.

  The default implementation calls `tf(float)`.

  Parameters:
    `freq` - the frequency of a term within a document
  Returns:
    a score factor based on a term's within-document frequency

### sloppyFreq

    public abstract float sloppyFreq(int distance)

  Computes the amount of a sloppy phrase match, based on an edit distance. This value is summed for each sloppy phrase match in a document to form the frequency that is passed to `tf(float)`.

  A phrase match with a small edit distance to a document passage more closely matches the document, so implementations of this method usually return larger values when the edit distance is small and smaller values when it is large.

  Parameters:
    `distance` - the edit distance of this sloppy phrase match
  Returns:
    the frequency increment for this match
  See Also:
    `PhraseQuery.setSlop(int)`

### tf

    public abstract float tf(float freq)

  Computes a score factor based on a term or phrase's frequency in a document. This value is multiplied by the `idf(int, int)` factor for each term in the query and these products are then summed to form the initial score for a document.

  Terms and phrases repeated in a document indicate the topic of the document, so implementations of this method usually return larger values when `freq` is large, and smaller values when `freq` is small.

  Parameters:
    `freq` - the frequency of a term within a document
  Returns:
    a score factor based on a term's within-document frequency

### idfExplain

    public Explanation.IDFExplanation idfExplain(Term term,
                                                 Searcher searcher,
                                                 int docFreq)
                                          throws IOException

  Computes a score factor for a simple term and returns an explanation for that score factor.

  The default implementation uses:

       idf(searcher.docFreq(term), searcher.maxDoc());

  Note that `Searcher.maxDoc()` is used instead of `IndexReader#numDocs()` because also `Searcher.docFreq(Term)` is used, and when the latter is inaccurate, so is `Searcher.maxDoc()`, and in the same direction. In addition, `Searcher.maxDoc()` is more efficient to compute

  Parameters:
    `term` - the term in question
    `searcher` - the document collection being searched
  Returns:
    an IDFExplain object that includes both an idf score factor and an explanation for the term.
  Throws:
    `IOException`

### idfExplain

    public Explanation.IDFExplanation idfExplain(Term term,
                                                 Searcher searcher)
                                          throws IOException

  This method forwards to `idfExplain(Term,Searcher,int)` by passing `searcher.docFreq(term)` as the docFreq. WARNING: if you subclass Similariary and override this method then you may hit a peformance hit for certain queries. Better to override `idfExplain(Term,Searcher,int)` instead.

  Throws:
    `IOException`

### idfExplain

    public Explanation.IDFExplanation idfExplain(Collection<Term> terms,
                                                 Searcher searcher)
                                          throws IOException

  Computes a score factor for a phrase.

  The default implementation sums the idf factor for each term in the phrase.

  Parameters:
    `terms` - the terms in the phrase
    `searcher` - the document collection being searched
  Returns:
    an IDFExplain object that includes both an idf score factor for the phrase and an explanation for each term.
  Throws:
    `IOException`

### idf

    public abstract float idf(int docFreq,
                              int numDocs)

  Computes a score factor based on a term's document frequency (the number of documents which contain the term). This value is multiplied by the `tf(int)` factor for each term in the query and these products are then summed to form the initial score for a document.

  Terms that occur in fewer documents are better indicators of topic, so implementations of this method usually return larger values for rare terms, and smaller values for common terms.

  Parameters:
    `docFreq` - the number of documents which contain the term
    `numDocs` - the total number of documents in the collection
  Returns:
    a score factor based on the term's document frequency

### coord

    public abstract float coord(int overlap,
                                int maxOverlap)

  Computes a score factor based on the fraction of all query terms that a document contains. This value is multiplied into scores.

  The presence of a large portion of the query terms indicates a better match with the query, so implementations of this method usually return larger values when the ratio between these parameters is large and smaller values when the ratio between them is small.

  Parameters:
    `overlap` - the number of query terms matched in the document
    `maxOverlap` - the total number of terms in the query
  Returns:
    a score factor based on term overlap with the query

### scorePayload

    public float scorePayload(int docId,
                              String fieldName,
                              int start,
                              int end,
                              byte[] payload,
                              int offset,
                              int length)

  Calculate a scoring factor based on the data in the payload. Overriding implementations are responsible for interpreting what is in the payload. Lucene makes no assumptions about what is in the byte array.

  The default implementation returns 1.

  Parameters:
    `docId` - The docId currently being scored. If this value is `NO_DOC_ID_PROVIDED`, then it should be assumed that the PayloadQuery implementation does not provide document information
    `fieldName` - The fieldName of the term this payload belongs to
    `start` - The start position of the payload
    `end` - The end position of the payload
    `payload` - The payload byte array to be scored
    `offset` - The offset into the payload array
    `length` - The length in the array
  Returns:
    An implementation dependent float to be used as a scoring factor

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD